import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

public class PreparedStatementTest {

	/**
	 * PreparedStatement 테스트
	 */
	Connection con;
	
	static{
		try{
			Class.forName("oracle.jdbc.driver.OracleDriver");
		}
		catch(ClassNotFoundException cne){
			cne.printStackTrace();
		}
	}
	public void connect(){
		try{
			con = DriverManager.getConnection("jdbc:oracle:thin:@localhost:1521:XE",
					"java", "java");
			System.out.println("Connection Success!");
		}
		catch(SQLException se){
			se.printStackTrace();
		}
	}
	public void insert(){
		PreparedStatement pstmt = null;
		
		try{
			String sql = "INSERT INTO member VALUES(?,?,?,?,?,?)";
			pstmt = con.prepareStatement(sql);
			pstmt.setString(1, "java");
			pstmt.setString(2, "java");
			pstmt.setString(3, "오정원");
			pstmt.setInt(4, 22);
			pstmt.setString(5, "남자");
			pstmt.setString(6, "java@java.com");
			
			int count = pstmt.executeUpdate();
			if(count > 0){
				System.out.println("insert success!");
			}
			else{
				System.out.println("insert fail");
			}
		}
		catch(SQLException se){
			System.out.println("insert fail");
			se.printStackTrace();
		}
		finally{
			try{
				pstmt.close();
				con.close();
			}
			catch(Exception e){
				e.printStackTrace();
			}
		}
	}
	public void select(){
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		
		try{
			String sql = "SELECT * FROM member";
			pstmt = con.prepareStatement(sql);
			
			rs = pstmt.executeQuery();
			while(rs.next()){
				System.out.println("아이디 : " + rs.getString(1) + ",비밀번호 : " 
			+ rs.getString("passwd") + ",이름 : " + rs.getString("name") + 
			",나이 : " + rs.getInt("age") + ",성별 : " + rs.getString("gender") + 
			",이메일 : " + rs.getString("email"));
			}			
		}
		catch(SQLException se){
			se.printStackTrace();
		}
		finally{
			try{
				pstmt.close();
				con.close();
			}
			catch(Exception e){
				e.printStackTrace();
			}
		}
	}
	public void update(){
		PreparedStatement pstmt = null;
		
		try{
			String sql = "UPDATE member SET gender = ? WHERE id = ?";
			pstmt = con.prepareStatement(sql);
			pstmt.setString(1, "여자");
			pstmt.setString(2, "java");
			
			int count = pstmt.executeUpdate();
			if(count > 0){
				System.out.println("update success!");
			}
			else{
				System.out.println("update fail");
			}
		}
		catch(SQLException se){
			System.out.println("update fail");
			se.printStackTrace();
		}
		finally{
			try{
				pstmt.close();
				con.close();
			}
			catch(Exception e){
				e.printStackTrace();
			}
		}
	}
	public void delete(){
		PreparedStatement pstmt = null;
		
		try{
			String sql = "DELETE member WHERE id = ?";
			pstmt = con.prepareStatement(sql);
			pstmt.setString(1, "java");
			
			int count = pstmt.executeUpdate();
			if(count > 0){
				System.out.println("delete success!");
			}
			else{
				System.out.println("delete fail");
			}
		}
		catch(SQLException se){
			System.out.println("delete fail");
			se.printStackTrace();
		}
		finally{
			try{
				pstmt.close();
				con.close();
			}
			catch(Exception e){
				e.printStackTrace();
			}
		}
	}
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		PreparedStatementTest pt = new PreparedStatementTest();
		pt.connect();
		pt.insert();
		
		System.out.println("insert 수행 후");
		pt.connect();
		pt.select();
		
		pt.connect();
		pt.update();
		
		System.out.println("update 수행 후");
		pt.connect();
		pt.select();
		
		pt.connect();
		pt.delete();
		
		System.out.println("delete 수행 후");
		pt.connect();
		pt.select();				
	}

}
