import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

public class ProcedureTest {

	/**
	 * Procedure 테스트
	 */
	Connection con;
	static{
		try{
			Class.forName("oracle.jdbc.driver.OracleDriver");
		}
		catch(ClassNotFoundException cne){
			cne.printStackTrace();
		}
	}
	public void connect(){
		try{
			con = DriverManager.getConnection("jdbc:oracle:thin:@localhost:1521:XE",
					"java", "java");
			System.out.println("Connection Success!");
		}
		catch(SQLException se){
			se.printStackTrace();
		}
	}
	public void select(){
		String sql = "SELECT * FROM member";
		PreparedStatement pstmt = null;
		ResultSet rs = null;

		try{
			connect();
			pstmt = con.prepareStatement(sql);
			rs = pstmt.executeQuery();
			while(rs.next()){
				System.out.println("아이디 : " + rs.getString(1) + ", 비밀번호 : " 
						+ rs.getString(2) + ", 이름 : " + rs.getString(3) + ", 나이 : "
						+ rs.getInt(4) + ", 성별 : " + rs.getString(5) + ", 이메일 : " 
						+ rs.getString("email"));
			}			
		}
		catch(SQLException se){
			se.printStackTrace();
		}
		finally{
			try{
				pstmt.close();
				con.close();
			}
			catch(Exception e){
				e.printStackTrace();
			}
		}
	}
	public void insertMember(){
		CallableStatement cs = null;
		
		try{
			connect();
			String sql = "{call user_insert(?,?,?,?,?,?)}";
			cs = con.prepareCall(sql);
			cs.setString(1, "protest");
			cs.setString(2, "1111");
			cs.setString(3, "김다슬");
			cs.setInt(4, 19);
			cs.setString(5, "여자");
			cs.setString(6, "pro@pro.com");
			int count = cs.executeUpdate();
			if(count > 0){
				System.out.println("insert success");
			}
			else{
				System.out.println("insert fail");
			}
		}
		catch(Exception e){
			e.printStackTrace();
		}
		finally{
			try{
				cs.close();
				con.close();
			}
			catch(Exception e){
				e.printStackTrace();
			}
		}
	}
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		ProcedureTest pt = new ProcedureTest();
		
		System.out.println("프로시저 호출 전 데이터");
		pt.select();
		
		System.out.println("프로시저 호출 후 데이터");
		pt.insertMember();
		pt.select();
	}

}

