import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;

public class ResultSetMetaDataTest {

	/**
	 * ResultSetMetaData 테스트
	 */
	Connection con;
	
	static{
		try{
			Class.forName("oracle.jdbc.driver.OracleDriver");
		}
		catch(ClassNotFoundException cne){
			cne.printStackTrace();
		}
	}
	public void connect(){
		try{
			con = DriverManager.getConnection("jdbc:oracle:thin:@localhost:1521:XE",
					"java", "java");
			System.out.println("Connection Success!");
		}
		catch(SQLException se){
			se.printStackTrace();
		}
	}
	
	public void printMetaData(){
		Statement stmt = null;
		ResultSet rs = null;
		ResultSetMetaData rsmd;
		try{
			connect();
			stmt = con.createStatement();
			String sql = "SELECT * FROM member";
			rs = stmt.executeQuery(sql);
			rsmd = rs.getMetaData();

            System.out.println("전체 컬럼 개수 : " +rsmd.getColumnCount());	
            System.out.println("두 번째 컬럼의 이름 : " + rsmd.getColumnName(2));
            System.out.println("두 번째 컬럼의 데이터타입 : " + rsmd.getColumnTypeName(2));
            System.out.println("두 번째 컬럼의 데이터타입의 크기 :" + rsmd.getPrecision(2));
            int isNull = rsmd.isNullable(2);
            if(isNull == 0){
            	System.out.println("두 번째 컬럼은 Not Null");
            }
            else{
            	System.out.println("두 번째 컬럼은 Nullable");
            }
            System.out.println("두 번째 컬럼의 자바  타입 : " + rsmd.getColumnClassName(2));
		}
		catch(SQLException se){
			se.printStackTrace();
		}
		finally{
			try{
				stmt.close();
				con.close();
			}
			catch(Exception e){
				e.printStackTrace();
			}
		}
	}
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		ResultSetMetaDataTest rt = new ResultSetMetaDataTest();
		rt.printMetaData();
	}

}

